# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

cloudId: Optional[str]
"""
The ID of the [Cloud](https://yandex.cloud/docs/resource-manager/concepts/resources-hierarchy#cloud) to apply any
resources to. This can also be specified using environment variable `YC_CLOUD_ID`.
"""

endpoint: Optional[str]
"""
The endpoint for API calls, default value is **api.cloud.yandex.net:443**. This can also be defined by environment
variable `YC_ENDPOINT`.
"""

folderId: Optional[str]
"""
The ID of the [Folder](https://yandex.cloud/docs/resource-manager/concepts/resources-hierarchy#folder) to operate under,
if not specified by a given resource. This can also be specified using environment variable `YC_FOLDER_ID`.
"""

insecure: Optional[bool]
"""
Explicitly allow the provider to perform "insecure" SSL requests. If omitted, default value is `false`.
"""

maxRetries: Optional[int]
"""
This is the maximum number of times an API call is retried, in the case where requests are being throttled or
experiencing transient failures. The delay between the subsequent API calls increases exponentially.
"""

organizationId: Optional[str]
"""
The ID of the [Cloud Organization](https://yandex.cloud/docs/organization/quickstart) to operate under.
"""

plaintext: Optional[bool]
"""
Disable use of TLS. Default value is `false`.
"""

profile: Optional[str]
"""
Profile name to use in the shared credentials file. Default value is `default`.
"""

regionId: Optional[str]
"""
[The region](https://yandex.cloud/docs/overview/concepts/region) where operations will take place. For example
`ru-central1`.
"""

serviceAccountKeyFile: Optional[str]
"""
Contains either a path to or the contents of the [Service Account
file](https://yandex.cloud/docs/iam/concepts/authorization/key) in JSON format. This can also be specified using
environment variable `YC_SERVICE_ACCOUNT_KEY_FILE`. You can read how to create service account key file
[here](https://yandex.cloud/docs/iam/operations/iam-token/create-for-sa#keys-create). > Only one of `token` or
`service_account_key_file` must be specified. > One can authenticate via instance service account from inside a compute
instance. In order to use this method, omit both `token`/`service_account_key_file` and attach service account to the
instance. [Working with Yandex Cloud from inside an
instance](https://yandex.cloud/docs/compute/operations/vm-connect/auth-inside-vm).
"""

sharedCredentialsFile: Optional[str]
"""
Shared credentials file path. Supported keys: `storage_access_key` and `storage_secret_key`. > The `storage_access_key`
and `storage_secret_key` attributes from the shared credentials file are used only when the provider and a storage
data/resource do not have an access/secret keys explicitly specified.
"""

storageAccessKey: Optional[str]
"""
Yandex Cloud Object Storage access key, which is used when a storage data/resource doesn't have an access key explicitly
specified. This can also be specified using environment variable `YC_STORAGE_ACCESS_KEY`.
"""

storageEndpoint: Optional[str]
"""
Yandex Cloud [Object Storage Endpoint](https://yandex.cloud/docs/storage/s3/#request-url), which is used to connect to
`S3 API`. Default value is **storage.yandexcloud.net**.
"""

storageSecretKey: Optional[str]
"""
Yandex Cloud Object Storage secret key, which is used when a storage data/resource doesn't have a secret key explicitly
specified. This can also be specified using environment variable `YC_STORAGE_SECRET_KEY`.
"""

token: Optional[str]
"""
Security token or IAM token used for authentication in Yandex Cloud. Check
[documentation](https://yandex.cloud/docs/iam/operations/iam-token/create) about how to create IAM token. This can also
be specified using environment variable `YC_TOKEN`.
"""

ymqAccessKey: Optional[str]
"""
Yandex Cloud Message Queue service access key, which is used when a YMQ queue resource doesn't have an access key
explicitly specified. This can also be specified using environment variable `YC_MESSAGE_QUEUE_ACCESS_KEY`.
"""

ymqEndpoint: Optional[str]
"""
Yandex Cloud Message Queue service endpoint. Default value is **message-queue.api.cloud.yandex.net**.
"""

ymqSecretKey: Optional[str]
"""
Yandex Cloud Message Queue service secret key, which is used when a YMQ queue resource doesn't have a secret key
explicitly specified. This can also be specified using environment variable `YC_MESSAGE_QUEUE_SECRET_KEY`.
"""

zone: Optional[str]
"""
The default [availability zone](https://yandex.cloud/docs/overview/concepts/geo-scope) to operate under, if not
specified by a given resource. This can also be specified using environment variable `YC_ZONE`.
"""

